﻿<?php
/*
	Plugin autoTrackManager
	Removes/Deletes tracks from tracklist if track karma got lower than a given value

	Written by ck|cyrus
	martin@die-webber.com
	www.chaoskrieger.com
	
	modified by W1lla
	
	modified for TM2 by sotn0r | markus@nc1.eu | https://nc1.eu 
*/

Aseco::registerEvent("onSync", "atm_init");
Aseco::registerEvent("onBeginMap", "atm_onBeginMap");
Aseco::registerEvent("onChat", "atm_onchat");

Aseco::addChatCommand('atm', 'Show autoTrackManager infos/options');
Aseco::addChatCommand('atm setminvotes', 'Min. votes needed to activate autotrackmanager for this track');
Aseco::addChatCommand('atm setpercent',  'percentage 40% bad 60% good');
Aseco::addChatCommand('atm switchdebug',  'sets debug on/off');
Aseco::addChatCommand('atm switchatmlogfile',  'Logfile to log removed tracks | Leave emtpy to disable logging ');
Aseco::addChatCommand('atm switchwritematchsetting',  'Set to true/false if matchsetting file should be updated after ATM action');
Aseco::addChatCommand('atm switchdbfree', 'Set to true/false if database entries should be deleted too');
Aseco::addChatCommand('atm switchtrackhandle',  'Set to "remove" or "erase" to specify what to do with the map if it will be sort out ');
Aseco::addChatCommand('atm switchstatus', 'sets to on/off');


//pass event to class
function atm_onBeginMap($aseco, $map) { global $atm; $atm->onBeginMap($map); }
function atm_onchat($aseco, $data) { global $atm; $atm->onChat($data); }

if(!defined('CRLF')) define('CRLF', "\r\n");
if(!defined('CR')) define('CR', "\r");
if(!defined('LF')) define('LF', "\n");

//init class and start it
function atm_init($aseco,$command)
	{
	global $atm;
	$atm = new atm($aseco);
	}
		
class atm
	{
	var $aseco;
	var $atmcfg;
	var $mcolor;
	var $showname;
	
	function atm($aseco)
		{
		$this->aseco = $aseco;

		//load config
		$this->cfg = $this->loadAtmCfg('plugin.autotrackmanager.config.xml');	
		$this->cfg['ENABLED'][0] = 1;
		$this->cfg['VERSION'][0] = '0.4';
		
		$this->mcolor = array('headline' => '0D0F',
							   'normal' => '00FF',
							   'red' => 'F00F',
							   'green' => '0D0F',
							   'blue' => '00FF',
							   'cellbg' => '222C',
							   );

		if($aseco->server->getGame() == 'MP') 
			$this->showname = '$l[http://tmserver.eu/xaseco/plugin.autotrackmanager_tm2.zip]autoTrackManager$l';
		else
			trigger_error('[autoTrackManager]', 'Invalid game version. This plugin is only compatible with Trackmania 2.');
		

		echo('###############################################' . CRLF);
		echo('## AutoTrackManager v.'.$this->cfg['VERSION'][0].' loaded' . CRLF);
		echo('## Original by ck|cyrus (martin@die-webber.com)' . CRLF);
		echo('## edited for Xaseco by W1lla (w1llaopgezwolle@gmail.com)' . CRLF); 
		echo('## edited for Xaseco on Trackmania 2 by sotn0r (markus@nc1.eu)' . CRLF); 
		echo('###############################################' . CRLF);
		
		$msg = $this->aseco->formatColors('{#server}>> '.$this->showname.' {#message}loaded successfully! Type /atm');
		
		$aseco->client->query('ChatSendServerMessage', $msg);
		
		}
	
	function autotrackmanager()
		{
		$votecount = 0;
		$voteminus = 0;
		$voteplus = 0;
		
		//Avoid division with 0
		if(empty($this->cfg['MINVOTES'][0]) || $this->cfg['MINVOTES'][0] == 0) $this->cfg['MINVOTES'][0] = 1;
		
		//Get last map info
		$mapinfo = $this->get_trackinfo("-1");
	
		//Get map id
		$query = "SELECT ID FROM maps WHERE Uid = '".$mapinfo->uid."' LIMIT 0,1";
	  	$result = mysql_query($query);
	  	$row = mysql_fetch_row($result);
	
	  	//Get Karma
	  	$query = "select sum(score) from rs_karma where Score < '0' and MapId='" . $row[0]."'";
		$res = mysql_query($query);
		$temp = mysql_fetch_row($res);
		if(is_numeric($temp[0])) 
			$voteminus = abs($temp[0]);
		else 
			$voteminus = 0;
		$query = "select sum(score) from rs_karma where Score > '0' and MapId='" . $row[0]."'";
		$res = mysql_query($query);
		$temp = mysql_fetch_row($res);
		if(is_numeric($temp[0])) 
			$voteplus = $temp[0];
		else 
			$voteplus = 0;
		
		mysql_free_result($res);
		
		$votecount = $voteplus+$voteminus;
		//Check track karma status
		
		if($this->cfg['DEBUG'][0] == 'true') $this->aseco->console('ATM Debug: minvotes: '.$this->cfg['MINVOTES'][0]);
		if($this->cfg['DEBUG'][0] == 'true') $this->aseco->console('ATM Debug: plus:'.$voteplus.', minus: '.$voteminus.', ratio: '.( ( $votecount>0 )?( round($voteplus/$votecount,2) ):('n/a') ));
		
		if($votecount >= $this->cfg['MINVOTES'][0] && $voteplus/$votecount <= $this->cfg['RATIO'][0]) 
			{
			if($this->cfg['DEBUG'][0] == 'true') $this->aseco->console('ATM Debug: Track too bad: '.stripcolors($mapinfo->name));
			//Track is too bad. Going to work ;)
			//Remove from Tracklist
			$filename = $this->aseco->server->mapdir . $mapinfo->filename;
			$set = $this->aseco->client->addCall('RemoveMap', array($filename));
			if (!$this->aseco->client->multiquery())
				{
				//Error
				trigger_error('[' . $this->aseco->client->getErrorCode() . '] ' . $this->aseco->client->getErrorMessage());
				}
			else
				{
				//Remove successfull
				$msg = '{#message}>> '.$this->showname.' {#message}removed track: ' . stripcolors($mapinfo->name).'{#message} due to bad karma [ratio: '.round ($voteplus/$votecount,2).']';
				
				//Check if trackhandle = erase
				if(strtolower($this->cfg['TRACKHANDLE'][0]) == 'erase' && is_file($filename))
					{

					//Erase track and infos from Database
					if ( unlink($filename) )
						{
						
						//Erase successfull
						$msg = '{#message}>> '.$this->showname.' {#message}erased track: ' . stripcolors($mapinfo->name).'{#message} due to bad karma [ratio: '.round ($voteplus/$votecount,2).']';
	
						//Log
						$log = 'Erased track '.stripFormatting($mapinfo->name).' [ratio: '.round ($voteplus/$votecount,2).']';
						$this->aseco->console('[ATM] Erased track '.stripFormatting($mapinfo->name).' [ratio: '.round ($voteplus/$votecount,2).']');
	
						}
					else
						{
						//Error erasing track
						$this->aseco->console('[ATM] [ERROR] erasing track '.stripFormatting($mapinfo->name));
						}
	
					}
				else
					{
					//Removed from tracklist
					$log = 'Removed track '.stripFormatting($mapinfo->name).' [ratio: '.round ($voteplus/$votecount,2).']';
					$this->aseco->console('[ATM] Removed track '.stripFormatting($mapinfo->name).' [ratio: '.round ($voteplus/$votecount,2).']');
					}
	
				$this->aseco->addCall('ChatSendServerMessage', array($this->aseco->formatColors($msg)));
	
				//Clean DB if set
				if(strtolower($this->cfg['DBFREE'][0]) == 'true')
					{
					//Get map id
					$query = 'SELECT ID FROM maps WHERE Uid = ' . quotedString($mapinfo->uid) . ' LIMIT 0,1';
					$result = mysql_query($query);
					$row = mysql_fetch_row($result);
	
					$query = 'DELETE FROM maps WHERE Id = ' . $row[0];
					$result = mysql_query($query);
	
					if (mysql_affected_rows() == 0)
						$log .= ' | [DB:map] no row';
					else
						$log .= ' | [DB:map] OK';
	
					$query = 'DELETE FROM records WHERE MapId = '.$row[0];
					$result = mysql_query($query);
	
					if (mysql_affected_rows() == 0)
						$log .= ' | [DB:records] no row';
					else
						$log .= ' | [DB:records] OK';
	
					$query = 'DELETE FROM rs_karma WHERE MapId = '.$row[0];
					$result = mysql_query($query);
	
					if (mysql_affected_rows() == 0)
						$log .= ' | [DB:karma] no row';
					else
						$log .= ' | [DB:karma] OK';
	
					$query = 'DELETE FROM rs_times WHERE MapId = ' . $row[0];
					$result = mysql_query($query);
	
					if (mysql_affected_rows() == 0)
						$log .= ' | [DB:times] no row';
					else
						$log .= ' | [DB:times] OK';
					}
				
	
				//Do matchsetting save if set
				if(strtolower($this->cfg['WRITEMATCHSETTING'][0]) == 'true')
					{
					//$command['params'][0] = 'writetracklist';
					//Call Rasp function
					//chat_admin($this->aseco, $command);
					
					$this->aseco->addCall('SaveMatchSettings', array('rasp-tracklist.txt'));
					if ($this->aseco->client->multiquery()) $log .= ' | Matchsetting written';
					}
					
				//Write logfile
				$this->writelog($log);
				}
			
			}
		
	
		}
	function writelog($text)
		{
		if(!empty($this->cfg['ATMLOGFILE'][0]))	file_put_contents($this->cfg['ATMLOGFILE'][0], '['.date("Y-m-d H:i").' v.'.$this->cfg['VERSION'][0].'] '.$text.CRLF, FILE_APPEND);
		}
		
	function get_trackinfo($offsetToCurrentTrack = 1) //offset default 1 (next track) e.g. -1 would be last track
		{
		//Get Tracklist
		$maps = $this->aseco->client->addCall("GetMapList", array(500, 0));
		if (!$this->aseco->client->multiquery())
			{
			trigger_error('[' . $this->aseco->client->getErrorCode() . '] ' . $this->aseco->client->getErrorMessage());
			$mapresponse = array();
			return false;
			}
		
		$mapresponse = $this->aseco->client->getResponse();
		
		//Number of Maps
		$mapCount = count($mapresponse[$maps][0]);
		//Get Current Trackposition
		$mapid = $this->aseco->client->addCall("GetCurrentMapIndex", array());
		if (!$this->aseco->client->multiquery())
			{
			trigger_error('[' . $this->aseco->client->getErrorCode() . '] ' . $this->aseco->client->getErrorMessage());
			$mapidresponse = array();
			return false;
			}
		$mapidresponse = $this->aseco->client->getResponse();
		
		//Current Map Index
		$mapIndex = $mapidresponse[$mapid][0];
		//Handle swap...
		if($mapIndex+$offsetToCurrentTrack >= $mapCount)
			{
			//End of Tracklist
			$getMapIndex = $mapIndex+$offsetToCurrentTrack-$mapCount;
			}
		elseif($mapIndex+$offsetToCurrentTrack < 0)
			{
			$getMapIndex = $mapCount+$mapIndex+$offsetToCurrentTrack;
			}
		else
			{
			$getMapIndex = $mapIndex+$offsetToCurrentTrack;
			}
		//Get Map Infos
		$gettrackinfo = $this->aseco->client->addCall("GetMapInfo", array($mapresponse[$maps][0][$getMapIndex]['FileName']));
		if (!$this->aseco->client->multiquery())
			{
			trigger_error('[' . $this->aseco->client->getErrorCode() . '] ' . $this->aseco->client->getErrorMessage());
			$gettrackinfo = array();
			return false;
			}
		$gettrackinforesponse = $this->aseco->client->getResponse();
		return new Map($gettrackinforesponse[$gettrackinfo][0]);
		}
	function loadAtmCfg($config_file)
		{
		//Load config file
		if(!file_exists($config_file))
			{
			$this->aseco->console("[ATM] [ERROR] Can't find config files : '".$config_file."'");
			exit(0);
			}
		if ($xml = $this->aseco->xml_parser->parseXml($config_file)) 
			{
			return $xml['ATMCFG'];
			} 
		else 
			{
			$this->aseco->console("[ATM] [ERROR] Error in config XML file '".$config_file."'");
			exit(0);
			}
		}
	
	//chatfunctions
	function switchstatus($login)
		{
		if($this->cfg['ENABLED'][0] == 1) 
			{
			$this->cfg['ENABLED'][0] = 0;
			$msg = $this->aseco->formatColors('{#server}>> {#message}Admin disabled {#message} '.$this->showname.'!');
			$this->aseco->addCall("ChatSendServerMessage", array($msg));
			}
		elseif($this->cfg['ENABLED'][0] == 0)
			{
			$this->cfg['ENABLED'][0] = 1;
			$msg = $this->aseco->formatColors('{#server}>> {#message}Admin enabled {#message} '.$this->showname.'!');
			$this->aseco->addCall("ChatSendServerMessage", array($msg));
			}
		else
			{
			$msg = $this->aseco->formatColors('{#server}>> {#message}autoTrackManager already '.$action.'d!');
			$this->aseco->addCall("ChatSendServerMessageToLogin", array($msg, $login));
			}
		}
		
	function switchtrackhandle($login)
		{
		if(strtolower($this->cfg['TRACKHANDLE'][0]) == 'erase') 
			{
			$this->cfg['TRACKHANDLE'][0] = 'remove';
			}
		elseif(strtolower($this->cfg['TRACKHANDLE'][0]) == 'remove')
			{
			$this->cfg['TRACKHANDLE'][0] = 'erase';
			}
		}
	function switchdbfree($login)
		{
		if(strtolower($this->cfg['DBFREE'][0]) == 'true') 
			{
			$this->cfg['DBFREE'][0] = 'false';
			}
		elseif(strtolower($this->cfg['DBFREE'][0]) == 'false')
			{
			$this->cfg['DBFREE'][0] = 'true';
			}
		}
	function switchwritematchsetting($login)
		{
		if(strtolower($this->cfg['WRITEMATCHSETTING'][0]) == 'true') 
			{
			$this->cfg['WRITEMATCHSETTING'][0] = 'false';
			}
		elseif(strtolower($this->cfg['WRITEMATCHSETTING'][0]) == 'false')
			{
			$this->cfg['WRITEMATCHSETTING'][0] = 'true';
			}
		}
	function switchatmlogfile($login)
		{
		if(empty($this->cfg['ATMLOGFILE'][0])) 
			{
			$cfg = $this->loadAtmCfg('.plugin.autotrackmanager.config.xml');	
			if(!empty($cfg['ATMLOGFILE'][0])) 
				$this->cfg['ATMLOGFILE'][0] = $cfg['ATMLOGFILE'][0];
			else
				$this->cfg['ATMLOGFILE'][0] = 'ATM_logfile.txt';
			}
		elseif(!empty($this->cfg['ATMLOGFILE'][0]))
			{
			$this->cfg['ATMLOGFILE'][0] = '';
			}
		}
	function switchdebug($login)
		{
		if(strtolower($this->cfg['DEBUG'][0]) == 'true') 
			{
			$this->cfg['DEBUG'][0] = 'false';
			}
		elseif(strtolower($this->cfg['DEBUG'][0]) == 'false')
			{
			$this->cfg['DEBUG'][0] = 'true';
			}
		}
		
	function setpercent($percent, $login)
		{
		if(!empty($percent)) 
			{
			if(is_numeric($percent))
				{
				$this->cfg['RATIO'][0] = $percent/100;
				$msg = $this->aseco->formatColors('{#server}>> {#message}Admin set '.$this->showname.' {#message} percent to: '.round($percent,3).'%');
				$this->aseco->addCall("ChatSendServerMessage", array($msg));
				}
			else
				{
				// Input not numeric
				$msg = $this->aseco->formatColors('{#server}>> {#message}You have to give a numeric value for /atm setpercent{#message}!');	
				$this->aseco->addCall("ChatSendServerMessageToLogin", array($msg, $login));	
				}			
			}
		else
			{
			$msg = $this->aseco->formatColors('{#server}>> {#message}'.$this->showname.' current percent limit {#message} is: '.round($this->cfg['RATIO'][0]*100,3).'%');
			$this->aseco->addCall("ChatSendServerMessageToLogin", array($msg, $login));
			}
		}
	
	function setminvotes($votes, $login)
		{
		if(!empty($votes) || $votes == 0) 
			{
			if(is_numeric($votes) && $votes >=1)
				{
				$this->cfg['MINVOTES'][0] = $votes;
				$msg = $this->aseco->formatColors('{#server}>> {#message}Admin set '.$this->showname.' {#message} min. votes to: '.$votes);
				$this->aseco->addCall("ChatSendServerMessage", array($msg));
				}
			else
				{
				$msg = $this->aseco->formatColors('{#server}>> {#message}You have to give a numeric value greater than 0 for /atm setminvotes{#message}!');
				$this->aseco->addCall("ChatSendServerMessageToLogin", array($msg, $login));
				}
			
			}
		else
			{
			$msg = $this->aseco->formatColors('{#server}>> {#message}'.$this->showname.' current minimum votes {#message} are: '.$this->cfg['MINVOTES'][0]);
			$this->aseco->addCall("ChatSendServerMessageToLogin", array($msg, $login));
			}
		}
		
	////////////////////////////////////////
	// Info Display TMN TMO TMS
	function showInfoTMN($login, $aseco, $command)
		{
		//Only admin get more infos
			$admin = $command['author'];
	$login = $admin->login;

	// split params into arrays
	//$arglist = explode(' ', trim($command['params']), 2);
	//$command['params'] = explode(' ', trim($command['params']));

	// check if chat command was allowed for a masteradmin/admin/operator
	if ($aseco->isMasterAdmin($admin)) {
		$logtitle = 'MasterAdmin';
		$chattitle = $aseco->titles['MASTERADMIN'][0];
	} else {
		if ($aseco->isAdmin($admin) && $aseco->allowAdminAbility($command['params'][0])) {
			$logtitle = 'Admin';
			$chattitle = $aseco->titles['ADMIN'][0];
		} else {
			if ($aseco->isOperator($admin) && $aseco->allowOpAbility($command['params'][0])) {
				$logtitle = 'Operator';
				$chattitle = $aseco->titles['OPERATOR'][0];
			} else {
				// write warning in console
				$aseco->console($login . ' tried to use admin chat command (no permission!): ' . $arglist[0] . ' ' . $arglist[1]);
				// show chat message
				$aseco->client->query('ChatSendToLogin', $aseco->formatColors('{#error}You don\'t have the required admin rights to do that!'), $login);
				return false;
			}
		}
	}

	// check for unlocked password (or unlock command)
	if ($aseco->settings['lock_password'] != '' && !$admin->unlocked &&
	    $command['params'][0] != 'unlock') {
		// write warning in console
		$aseco->console($login . ' tried to use admin chat command (not unlocked!): ' . $arglist[0] . ' ' . $arglist[1]);
		// show chat message
		$aseco->client->query('ChatSendToLogin', $aseco->formatColors('{#error}You don\'t have the required admin rights to do that!'), $login);
		return false;
	}
		$header = ('AutoTrackManager $f80$s$iAdmin Panel$z');
		$data[] = array();
		$data[] = array('$zTracks will be '.$this->cfg['TRACKHANDLE'][0].'d');
		$data[] = array('$zDatabase will '.( (strtolower($this->cfg['DBFREE'][0])=='false') ? ('$'.substr($this->mcolor['red'], 0, 3).'not be cleaned') : ('$'.substr($this->mcolor['green'], 0, 3).'be cleaned') ));
		$data[] = array('$zMatchsetting will '.( (strtolower($this->cfg['WRITEMATCHSETTING'][0])=='false') ? ('$'.substr($this->mcolor['red'], 0, 3).'not be written') : ('$'.substr($this->mcolor['green'], 0, 3).'be written') ));
		$data[] = array('$zLogfile will '.( ($this->cfg['ATMLOGFILE'][0]=='') ? ('$'.substr($this->mcolor['red'], 0, 3).'not be written') : ('$'.substr($this->mcolor['green'], 0, 3).'be written') ));
		$data[] = array('$zDebug mode: '. ((strtolower($this->cfg['DEBUG'][0])=='false') ? ('$'.substr($this->mcolor['red'], 0, 3).'OFF') : ('$'.substr($this->mcolor['green'], 0, 3).'ON') ));
		$data[] = array('$zStatus: '.( ($this->cfg['ENABLED'][0] == 0) ? ('$'.substr($this->mcolor['red'], 0, 3).'disabled') : ('$'.substr($this->mcolor['green'], 0, 3).'enabled') ));
		$data[] = array('$zMin. votes: '.$this->cfg['MINVOTES'][0]);
		$data[] = array('$zVote percent: '.($this->cfg['RATIO'][0]*100).'%');
		display_manialink($command['author']->login, $header, array('Icons64x64_1', 'TrackInfo', -0.01), $data, array(0.9), 'OK');
		
		}
	//events
	function onBeginMap($map)
		{
		//run only if atm is activated
		if($this->cfg['ENABLED'][0] == 1) $this->autotrackmanager();
		}
	
	////////////////////////////////////////
	// Change options TMU
	function onPlayerServerMessageAnswer($answer)
		{	

		$login = $answer[1];
		//Only admin can change settings
			$admin = $command['author'];
	$login = $admin->login;

	$arglist = $command['params'];
	
	// check if chat command was allowed for a masteradmin/admin/operator
	if ($aseco->isMasterAdmin($admin)) {
		$logtitle = 'MasterAdmin';
		$chattitle = $aseco->titles['MASTERADMIN'][0];
	} else {
		if ($aseco->isAdmin($admin) && $aseco->allowAdminAbility($command['params'][0])) {
			$logtitle = 'Admin';
			$chattitle = $aseco->titles['ADMIN'][0];
		} else {
			if ($aseco->isOperator($admin) && $aseco->allowOpAbility($command['params'][0])) {
				$logtitle = 'Operator';
				$chattitle = $aseco->titles['OPERATOR'][0];
			} else {
				// write warning in console
				$aseco->console($login . ' tried to use admin chat command (no permission!): ' . $arglist[0] . ' ' . $arglist[1]);
				// show chat message
				$aseco->client->query('ChatSendToLogin', $aseco->formatColors('{#error}You don\'t have the required admin rights to do that!'), $login);
				return false;
			}
		}
	}

	// check for unlocked password (or unlock command)
	if ($aseco->settings['lock_password'] != '' && !$admin->unlocked &&
	    $command['params'][0] != 'unlock') {
		// write warning in console
		$aseco->console($login . ' tried to use admin chat command (not unlocked!): ' . $arglist[0] . ' ' . $arglist[1]);
		// show chat message
		$aseco->client->query('ChatSendToLogin', $aseco->formatColors('{#error}You don\'t have the required admin rights to do that!'), $login);
		return false;
	}
			
		switch($answer[2])
			{
			case '1234560':
				// ENABLE - DISABLE
				$this->switchstatus($login);
			break;
			
			case '1234561':
				// SETPERCENT
				$msg = $this->aseco->formatColors('{#server}>> {#message}Use /atm setpercent VALUE{#message} (e.g. "/atm setpercent 60" = 60% min. approval rating!');
				$this->aseco->addCall("ChatSendServerMessageToLogin", array($msg, $login));
			break;
			
			case '1234562':
				// SETMINVOTES
				$msg = $this->aseco->formatColors('{#server}>> {#message}Use /atm setminvotes VALUE{#message} (e.g. "/atm setminvotes 30" = 30 votes needed that ATM works!');
				$this->aseco->addCall("ChatSendServerMessageToLogin", array($msg, $login));
			break;
			
			case '1234563':
				// TRACKHANDLE
				$this->switchtrackhandle($login);
			break;
			
			case '1234564':
				// DATABASE
				$this->switchdbfree($login);
			break;
			
			case '1234565':
				// MATCHSETTING
				$this->switchwritematchsetting($login);
			break;
			
			case '1234566':
				// LOGFILE
				$this->switchatmlogfile($login);
			break;
			
			case '1234567':
				// DEBUG
				$this->switchdebug($login);
			break;
			
			default:
			
			break;
			}
		}
	function onChat($data)
		{

		}
	}
	
if(!function_exists('stripFormatting'))
	{
	function stripFormatting($input)
		{
		// now at something like rev 12 of stripColors, now called stripFormatting
		return str_replace("\0", '$$', preg_replace('/\\$([0-9a-f]..|[hl]\\[.*?\\]|.|$)/i', '', str_replace('$$', "\0", $input)));
		}
	}
if(!function_exists('quotedString'))
	{
	function quotedString($str_in)
		{
		return '\'' . mysql_real_escape_string($str_in) . '\'';
		}  //  quotedString
	}	
	
	
function chat_atm($aseco,$command)
	{	
	global $atm;
	
	$params = explode(" ", $command['params']);
	$login = $command['author']->login;

		
	// ONLY ADMIN FUNCS HERE
		$admin = $command['author'];
	$login = $admin->login;

	// split params into arrays
	$arglist = explode(' ', trim($command['params']), 2);
	$command['params'] = explode(' ', trim($command['params']));

	// check if chat command was allowed for a masteradmin/admin/operator
	if ($aseco->isMasterAdmin($admin)) {
		$logtitle = 'MasterAdmin';
		$chattitle = $aseco->titles['MASTERADMIN'][0];
	} else {
		if ($aseco->isAdmin($admin) && $aseco->allowAdminAbility($command['params'][0])) {
			$logtitle = 'Admin';
			$chattitle = $aseco->titles['ADMIN'][0];
		} else {
			if ($aseco->isOperator($admin) && $aseco->allowOpAbility($command['params'][0])) {
				$logtitle = 'Operator';
				$chattitle = $aseco->titles['OPERATOR'][0];
			} else {
				// write warning in console
				$aseco->console($login . ' tried to use admin chat command (no permission!): ' . $arglist[0] . ' ' . $arglist[1]);
				// show chat message
				$aseco->client->query('ChatSendToLogin', $aseco->formatColors('{#error}You don\'t have the required admin rights to do that!'), $login);
				return false;
			}
		}
	}

	// check for unlocked password (or unlock command)
	if ($aseco->settings['lock_password'] != '' && !$admin->unlocked &&
	    $command['params'][0] != 'unlock') {
		// write warning in console
		$aseco->console($login . ' tried to use admin chat command (not unlocked!): ' . $arglist[0] . ' ' . $arglist[1]);
		// show chat message
		$aseco->client->query('ChatSendToLogin', $aseco->formatColors('{#error}You don\'t have the required admin rights to do that!'), $login);
		return false;
	}
	else
		{
		if(strtolower($params[0]) == 'setpercent')
			{
			$params[1] = str_replace(",", ".", $params[1]);
			$atm->setpercent(strtolower($params[1]),$login);
			}
		elseif(strtolower($params[0]) == 'setminvotes')
			{
			$atm->setminvotes(strtolower($params[1]),$login);
			}
		elseif(strtolower($params[0]) == 'switch')
			{
				
			if(strtolower($params[1]) == 'help' || strtolower($params[1]) == '') 
				{
				$msg = $aseco->formatColors('{#server}>> {#message}Switch '.$atm->showname.' {#message} options "/atm switch OPT": status, trackhandle, dbfree, matchsetting, logfile, debug');
				$aseco->addCall("ChatSendServerMessageToLogin", array($msg, $login));
				}
			elseif(strtolower($params[1]) == 'status')
				$atm->switchstatus($login);
			elseif(strtolower($params[1]) == 'trackhandle')
				$atm->switchtrackhandle($login);
			elseif(strtolower($params[1]) == 'dbfree')
				$atm->switchdbfree($login);
			elseif(strtolower($params[1]) == 'matchsetting')
				$atm->switchwritematchsetting($login);
			elseif(strtolower($params[1]) == 'logfile')
				$atm->switchatmlogfile($login);
			elseif(strtolower($params[1]) == 'debug')
				$atm->switchdebug($login);
			}
		}
	//Display updated info
	if ( $aseco->server->getGame() == 'MP' )
		$atm->showInfoTMN($login, $aseco, $command);
	
	}
?>
